﻿using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using Microsoft.Practices.Prism.Commands;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;

namespace XDGDoubleClickCommandCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        public DelegateCommand MyCommand { get; set; }


        Random r = new Random();       
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for(int i=0; i<15; i++)
            {
                Data.Add(new SampleData()
                {
                    ID = i,
                    Label = "Label " + i.ToString(),
                    Number = r.Next(1000)
                });
            }

            MyCommand = new DelegateCommand(MyCommand_Execute);
        }

        public void MyCommand_Execute()
        {
            var x = Mouse.DirectlyOver;

            if(!(x is DataRecordPresenter))
            {
                var y = Utilities.GetDescendantFromType(x as DependencyObject, typeof(DataRecordPresenter), false);
                var z = Utilities.GetAncestorFromType(x as DependencyObject, typeof(DataRecordPresenter), false);

                if(y !=null || z != null)
                {
                    if(y == null)
                    {                        
                        DataRecordPresenter drp = z as DataRecordPresenter;
                        DataRecord record = drp.Record as DataRecord;
                    }
                    else
                    {
                        DataRecordPresenter drp = y as DataRecordPresenter;
                        DataRecord record = drp.Record as DataRecord;
                    }
                }
            }
            else
            {
                DataRecordPresenter drp = x as DataRecordPresenter;
                DataRecord record = drp.Record as DataRecord;
            }            
        }
    }

    public class SampleData
    {
        public int ID { get; set; }
        public string Label { get; set; }
        public int Number { get; set; }
    }
}
